-- FICHERO PARA CREACION DE USUARIOS PARA LA APLICACION: 7_ROLES_Y_USUARIOS.sql
-- Autor: David Giraldez Sanchez
-- Tutor: Jordi Ferrer Duran

-- NOTA: Acentos eliminados intencionadamente para facilitar la lectura con cualquier configuracion del cliente.

-- TODOS LOS COMANDOS DE ESTE SCRIPT DEBERAN LANZARSE COMO SYS, O UN USUARIO CON LOS PERMISOS ADECUADOS

-- ELIMINAMOS LOS ROLES, POR SI EXISTEN PREVIAMENTE
-- DROP ROLE OPERADOR;
-- DROP ROLE SOLO_LECTURA;

-- CREAMOS EL ROL OPERADOR: SERÁ EL QUE SE ASIGNE A LOS USUARIOS DE LA APLICACIÓN, PARA QUE SOLO PUEDAN USAR LOS PROCEDIMIENTOS CREADOS.

CREATE ROLE OPERADOR;
GRANT CONNECT,RESOURCE TO OPERADOR;
GRANT EXECUTE ON TFG.PKG_ABM TO OPERADOR;
GRANT EXECUTE ON TFG.PKG_FUNCIONAMIENTO TO OPERADOR;
GRANT EXECUTE ON TFG.PKG_ESTADISTICAS TO OPERADOR;

-- CREAMOS EL ROL SOLO_LECTURA: SE ASIGNARA A LOS USUARIOS QUE SOLO VAYAN A TENER PERMISOS DE EJECUCIÓN DE LOS PROCEDIMIENTOS DE CONSULTA DE LAS ESTADISTICAS DE LA APLICACIÓN

CREATE ROLE SOLO_LECTURA;
GRANT CONNECT,RESOURCE TO SOLO_LECTURA;
GRANT EXECUTE ON TFG.PKG_ESTADISTICAS TO SOLO_LECTURA;

-- ELIMINAMOS LOS USUARIOS, POR SI EXISTEN PREVIAMENTE
-- DROP USER USR_OPERADOR CASCADE;
-- DROP USER USR_SOLO_LECTURA CASCADE;

-- CREAMOS LOS USUARIOS Y ASIGNAMOS LOS ROLES
-- NO INDICAMOS TABLESPACE POR DEFECTO, ASI QUE LES ASIGNARA USERS. NO NOS IMPORTA PORQUE NO ALOJARAN DATOS.

CREATE USER USR_OPERADOR IDENTIFIED BY GIRALDEZ; 
GRANT OPERADOR TO USR_OPERADOR;

CREATE USER USR_SOLO_LECTURA IDENTIFIED BY QUERY; 
GRANT SOLO_LECTURA TO USR_SOLO_LECTURA;