DECLARE
  RSP VARCHAR2(300);
  
  BEGIN 
    -- Comenzamos con las tablas maestras de estados: 
    -- ESTADO ACCION
    tfg.pkg_abm.alta_ESTADOACCION(1,'Definida',RSP);
    tfg.pkg_abm.alta_ESTADOACCION(2,'En Proceso',RSP);
    tfg.pkg_abm.alta_ESTADOACCION(3,'Acabada',RSP);
    tfg.pkg_abm.alta_ESTADOACCION(4,'En Revision',RSP);

    -- ESTADO VULNERABILIDAD
    tfg.pkg_abm.alta_estadovuln(1,'Identificada',RSP);
    tfg.pkg_abm.alta_estadovuln(2,'No Mitigada',RSP);
    tfg.pkg_abm.alta_estadovuln(3,'Parcialmente Mitigada',RSP);
    tfg.pkg_abm.alta_estadovuln(4,'Totalmente Mitigada',RSP);
END; 
/

DECLARE
  RSP VARCHAR2(300);
BEGIN
	-- INICIALIZAMOS LA TABLA TFG.ESTADISTICA
		
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (1,'Proceso de gestión interno que, teniendo en cuenta toda la información de que se dispone en la BD, ha tenido un mayor nombre de vulnerabilidades detectadas.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (2,'Porcentaje de vulnerabilidades que, en el momento de ejecutar la consulta, están totalmente mitigadas.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (3,'Número total de acciones de mitigación que, en el momento de ejecutar la consulta, no están totalmente acabadas.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (4,'Política de seguridad que, en el momento de ejecutar la consulta, ha tenido más incumplimientos (teniendo en cuenta todos los departamentos de la empresa).',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (5,'CONSULTA 5, SIN USO.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (6,'Teniendo en cuenta todas las auditorías externas realizadas, año en el cual se han detectado más incumplimientos (teniendo en cuenta sólo los detectados durante la auditoría).',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (7,'Porcentaje de vulnerabilidades críticas que, en el momento de ejecutar la consulta, tienen alguna acción de mitigación abierta (que no esté en estado “acabada”).',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (8,'Teniendo en cuenta el último año (el anterior al año en curso), título de la sesión formativa telemática que ha tenido un porcentaje menor de participantes en total.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (9,'Número de vulnerabilidades críticas detectadas internamente teniendo en cuenta todos los datos de que se dispone. Se consideran detectadas internamente si se detectaron en posterioridad al análisis realizado al inicio del proyecto por la consultora externa.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (10,'En el momento de ejecutar la consulta, porcentaje de acciones de mitigación en el sistema que están en los estados “en proceso” o “en revisión”.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (11,'Teniendo en cuenta todas las acciones de mitigación en estado “en proceso”, persona responsable con más acciones asignadas.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (12,'CONSULTA 12, SIN USO.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (13,'CONSULTA 13, TOP 5-1.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (14,'CONSULTA 13, TOP 5-2.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (15,'CONSULTA 13, TOP 5-3.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (16,'CONSULTA 13, TOP 5-4.',0);
	INSERT INTO TFG.ESTADISTICA (id_consulta,descripcion_consulta,resultado_consulta) VALUES (17,'CONSULTA 13, TOP 5-5.',0);
END;
/
DECLARE
  RSP VARCHAR2(300);
BEGIN
-- INSERTAMOS DATOS PARA LAS PRUEBAS DE FUNCIONAMIENTO

  -- 4 Departamentos
    tfg.pkg_abm.alta_departamento('Departamento_1',RSP);
    tfg.pkg_abm.alta_departamento('Departamento_2',RSP);
	tfg.pkg_abm.alta_departamento('Departamento_3',RSP);
	tfg.pkg_abm.alta_departamento('Departamento_4',RSP);
	
  -- 2 Analisis
	tfg.pkg_abm.alta_analisis('Analisis_1','EXTERNO','Equipo_1',SYSDATE - 1000,'','', RSP);
	tfg.pkg_abm.alta_analisis('Analisis_2','INTERNO','Equipo_2',SYSDATE - 900,'','', RSP);
	
  -- 6 Procesos
	tfg.pkg_abm.alta_proceso('Proceso_1','', RSP);
	tfg.pkg_abm.alta_proceso('Proceso_2','', RSP);
	tfg.pkg_abm.alta_proceso('Proceso_3','', RSP);
	tfg.pkg_abm.alta_proceso('Proceso_4','', RSP);
	tfg.pkg_abm.alta_proceso('Proceso_5','', RSP);
	tfg.pkg_abm.alta_proceso('Proceso_6','', RSP);
	
  -- 2 Sesiones de formacion
	tfg.pkg_abm.alta_sesion('Sesion_1','telematica', SYSDATE -400,RSP);
	tfg.pkg_abm.alta_sesion('Sesion_2','PRESENCIAL', SYSDATE -700,RSP);
	
  -- 6 Empleados
	tfg.pkg_abm.alta_empleado('11111111A','Nombre_1','Apellido_1_1','Apellido_2_1','email_1@empresa.uoc',111111111,1,RSP);
	tfg.pkg_abm.alta_empleado('11111111B','Nombre_2','Apellido_1_2','Apellido_2_2','email_2@empresa.uoc',222222222,2,RSP);
	tfg.pkg_abm.alta_empleado('11111111C','Nombre_3','Apellido_1_3','Apellido_2_3','email_3@empresa.uoc',333333333,3,RSP);
	tfg.pkg_abm.alta_empleado('11111111D','Nombre_4','Apellido_1_4','Apellido_2_4','email_4@empresa.uoc',444444444,4,RSP);
	tfg.pkg_abm.alta_empleado('11111111E','Nombre_5','Apellido_1_5','Apellido_2_5','email_5@empresa.uoc',555555555,1,RSP);
	tfg.pkg_abm.alta_empleado('11111111F','Nombre_6','Apellido_1_6','Apellido_2_6','email_6@empresa.uoc',666666666,2,RSP);
	
  -- 2 Politicas
	tfg.pkg_abm.alta_politica('Politica_1','',RSP);
	tfg.pkg_abm.alta_politica('Politica_2','',RSP);
	
  -- 2 Auditorias
	tfg.pkg_abm.alta_auditoria('Auditoria_1','EXTERNA',SYSDATE - 950,RSP);
	tfg.pkg_abm.alta_auditoria('Auditoria_2','INTERNA',SYSDATE - 350,RSP);
	
  -- 4 Estudios de Proceso
	tfg.pkg_abm.alta_estudioproceso(1,1,SYSDATE - 350,RSP);
	tfg.pkg_abm.alta_estudioproceso(1,2,SYSDATE - 350,RSP);
	tfg.pkg_abm.alta_estudioproceso(1,3,SYSDATE - 350,RSP);
	tfg.pkg_abm.alta_estudioproceso(2,4,SYSDATE - 350,RSP);

  -- 12 Muestreos
	tfg.pkg_abm.alta_muestreo(1,1,1,SYSDATE-450,RSP);
	tfg.pkg_abm.alta_muestreo(1,2,1,SYSDATE-250,RSP);
	tfg.pkg_abm.alta_muestreo(1,1,2,SYSDATE-450,RSP);
	tfg.pkg_abm.alta_muestreo(1,2,2,SYSDATE-250,RSP);
	tfg.pkg_abm.alta_muestreo(1,1,3,SYSDATE-450,RSP);
	tfg.pkg_abm.alta_muestreo(1,2,3,SYSDATE-250,RSP);
	tfg.pkg_abm.alta_muestreo(1,1,4,SYSDATE-450,RSP);
	tfg.pkg_abm.alta_muestreo(1,2,4,SYSDATE-250,RSP);
	tfg.pkg_abm.alta_muestreo(1,1,5,SYSDATE-450,RSP);
	tfg.pkg_abm.alta_muestreo(1,2,5,SYSDATE-250,RSP);
	tfg.pkg_abm.alta_muestreo(1,1,6,SYSDATE-450,RSP);
	tfg.pkg_abm.alta_muestreo(1,2,6,SYSDATE-250,RSP);
	
  -- 8 Vulnerabilidades
	tfg.pkg_abm.alta_vulnerabilidad(1,1,SYSDATE-999,1,0,'Vuln_NO_CRITICA_1','',RSP);
	tfg.pkg_abm.alta_vulnerabilidad(1,2,SYSDATE-998,1,1,'Vuln_CRITICA_1','',RSP);
	tfg.pkg_abm.alta_vulnerabilidad(1,3,SYSDATE-997,1,0,'Vuln_NO_CRITICA_1','',RSP);
	tfg.pkg_abm.alta_vulnerabilidad(1,4,SYSDATE-996,1,0,'Vuln_NO_CRITICA_1','',RSP);
	tfg.pkg_abm.alta_vulnerabilidad(1,5,SYSDATE-995,1,0,'Vuln_NO_CRITICA_1','',RSP);
	tfg.pkg_abm.alta_vulnerabilidad(1,1,SYSDATE-994,1,0,'Vuln_NO_CRITICA_1','',RSP);
	tfg.pkg_abm.alta_vulnerabilidad(2,1,SYSDATE-899,1,0,'Vuln_NO_CRITICA_1','',RSP);
	tfg.pkg_abm.alta_vulnerabilidad(2,2,SYSDATE-898,1,1,'Vuln_CRITICA_1','',RSP);

  -- 6 INCUMPLIMIENTOS
	tfg.pkg_abm.alta_incumplimiento(SYSDATE - 940,1,1,1,RSP);
	tfg.pkg_abm.alta_incumplimiento(SYSDATE - 940,1,1,1,RSP);
	tfg.pkg_abm.alta_incumplimiento(SYSDATE - 940,1,1,1,RSP);
	tfg.pkg_abm.alta_incumplimiento(SYSDATE - 940,1,1,1,RSP);
	tfg.pkg_abm.alta_incumplimiento(SYSDATE - 340,2,1,1,RSP);
	tfg.pkg_abm.alta_incumplimiento(SYSDATE - 930,1,2,1,RSP);

  -- 8 ACCIONES DE MITIGACION
	tfg.pkg_abm.alta_accion('Accion_1',SYSDATE+30,SYSDATE-1,'',1,1,1,RSP);
    tfg.pkg_abm.alta_accion('Accion_2',SYSDATE+30,SYSDATE-1,'',1,1,1,RSP);
	tfg.pkg_abm.alta_accion('Accion_3',SYSDATE+30,SYSDATE-1,'',1,1,1,RSP);
	tfg.pkg_abm.alta_accion('Accion_4',SYSDATE+30,SYSDATE-1,'',1,1,1,RSP);
	tfg.pkg_abm.alta_accion('Accion_5',SYSDATE+30,SYSDATE-1,'',6,1,1,RSP);
	tfg.pkg_abm.alta_accion('Accion_6',SYSDATE+30,SYSDATE-1,'',6,1,3,RSP);
	tfg.pkg_abm.alta_accion('Accion_7',SYSDATE+30,SYSDATE-1,'',6,1,2,RSP);
	tfg.pkg_abm.alta_accion('Accion_8',SYSDATE+30,SYSDATE-1,'',6,1,2,RSP);
	
  -- 8 ASIGNACIONES DE SESIONES A EMPLEADOS
	tfg.pkg_abm.alta_asignadasesion(1,1,RSP);
	tfg.pkg_abm.alta_asignadasesion(1,2,RSP);
	tfg.pkg_abm.alta_asignadasesion(1,3,RSP);
	tfg.pkg_abm.alta_asignadasesion(1,4,RSP);
	tfg.pkg_abm.alta_asignadasesion(1,5,RSP);
	tfg.pkg_abm.alta_asignadasesion(1,6,RSP);
	tfg.pkg_abm.alta_asignadasesion(2,1,RSP);
	tfg.pkg_abm.alta_asignadasesion(2,2,RSP);
  
END;


