-- FICHERO PARA CREACION DE USUARIOS: 1_TABLESPACE_Y_ESQUEMA_PRINCIPAL.sql
-- Autor: David Giraldez Sanchez
-- Tutor: Jordi Ferrer Duran

-- NOTA: Acentos eliminados intencionadamente para facilitar la lectura con cualquier configuracion del cliente.

-- TODOS LOS COMANDOS DE ESTE SCRIPT DEBERAN LANZARSE COMO SYS, O UN USUARIO CON LOS PERMISOS ADECUADOS (CREACION DE ESQUEMAS, Y ASIGNACION DE PERMISOS).

-- En el caso de que ya exista, descomentamos las siguientes dos líneas para eliminar tanto el esquema principal como el tablespace antes de volverlos a crear.

-- DROP USER "TFG" CASCADE;
-- DROP TABLESPACE "TS_TFG" INCLUDING CONTENTS AND DATAFILES CASCADE CONSTRAINTS;

-- CREAMOS EL TABLESPACE QUE ASIGNAREMOS POR DEFECTO AL ESQUEMA TFG; 
-- ASUMIMOS QUE LA INSTANCIA SE HA CREADO CON OMF, EN CASO CONTRARIO HAY QUE INDICAR RUTA Y NOMBRE DEL DATAFILE A CREAR
CREATE TABLESPACE TS_TFG DATAFILE SIZE 512M AUTOEXTEND ON NEXT 512M MAXSIZE UNLIMITED;

-- Y EL ESQUEMA PRINCIPAL DE LA APLICACION
CREATE USER "TFG" IDENTIFIED BY tfg2022 DEFAULT TABLESPACE "TS_TFG" TEMPORARY TABLESPACE "TEMP";

GRANT "CONNECT","RESOURCE" TO "TFG";

ALTER USER "TFG" DEFAULT ROLE "CONNECT", "RESOURCE";

GRANT CREATE SESSION, CREATE TABLE, CREATE VIEW, CREATE SEQUENCE, CREATE PROCEDURE, CREATE TRIGGER, CREATE MATERIALIZED VIEW TO "TFG";

ALTER USER "TFG" QUOTA UNLIMITED ON "TS_TFG";