CREATE OR REPLACE PACKAGE PKG_FUNCIONAMIENTO AS 

/* -- FICHERO PARA CREACION DE PAQUETE: Paquete para los procedimientos de funcionamiento del sistema: 
 * Actualizacion de campos calculados en las tablas del sistema, actualizacion de los campos de la tabla estadistica
 * Autor: David Giraldez Sanchez
 * Tutor: Jordi Ferrer Duran
 */ 
      
-- NOTA: Acentos eliminados intencionadamente para facilitar la lectura con cualquier configuracion del cliente.

-- ESTE SCRIPT DEBERA LANZARSE COMO USUARIO TFG, O EL USUARIO QUE QUERAMOS UTILIZAR COMO ESQUEMA PRINCIPAL DE LA APLICACION
-- AL LANZAR ESTE SCRIPT COMO USUARIO TFG, EL PAQUETE SE CREA EN SU ESQUEMA Y ES DE SU PROPIEDAD.

/****************************************
**** ACTUALIZACION CAMPOS CALCULADOS ****
*****************************************/
   
   PROCEDURE ACTUALIZAR_VULNERABILIDADES_DE_PROCESO(
   pProceso IN PROCESO.id_proceso%TYPE, 
   RSP OUT VARCHAR2);

   PROCEDURE ACTUALIZAR_PORCENTAJE_DE_DEPARTAMENTO ( 
   pDepto IN DEPARTAMENTO.id_departamento%TYPE,
   RSP OUT VARCHAR2);

	PROCEDURE ACTUALIZAR_ESTADO_VULNERABILIDAD (
	pVulnerabilidad IN VULNERABILIDAD.id_vulnerabilidad%TYPE, 
	RSP OUT VARCHAR2);
	
	PROCEDURE ACTUALIZAR_INCUMPLIMIENTOS_DE_POLITICA (
	pPolitica IN POLITICA.id_politica%TYPE, 
	RSP OUT VARCHAR2);

/**********************************
**** ACTUALIZACION ESTADISTICA ****
***********************************/

PROCEDURE ACTUALIZAR_CONSULTA_1 ( 
   RSP OUT VARCHAR2);

PROCEDURE ACTUALIZAR_CONSULTA_2 ( 
   RSP OUT VARCHAR2);

PROCEDURE ACTUALIZAR_CONSULTA_3 ( 
   RSP OUT VARCHAR2);

PROCEDURE ACTUALIZAR_CONSULTA_4 ( 
   RSP OUT VARCHAR2);

-- El resultado de la CONSULTA 5 se obtiene mirando directamente la tabla DEPARTAMENTO, no la registramos en la tabla ESTADISTICA.
-- Dejamos el "hueco" por coherencia con el modelo que hemos definido.
/* PROCEDURE ACTUALIZAR_CONSULTA_5 ( 
   RSP OUT VARCHAR2);
*/ 

PROCEDURE ACTUALIZAR_CONSULTA_6 ( 
   RSP OUT VARCHAR2);

PROCEDURE ACTUALIZAR_CONSULTA_7 ( 
   RSP OUT VARCHAR2);

PROCEDURE ACTUALIZAR_CONSULTA_8 ( 
   RSP OUT VARCHAR2);

PROCEDURE ACTUALIZAR_CONSULTA_9 ( 
   RSP OUT VARCHAR2);

PROCEDURE ACTUALIZAR_CONSULTA_10 ( 
   RSP OUT VARCHAR2);

PROCEDURE ACTUALIZAR_CONSULTA_11 ( 
   RSP OUT VARCHAR2);
   
END PKG_FUNCIONAMIENTO;