CREATE OR REPLACE PACKAGE PKG_ABM AS 

/* -- FICHERO PARA CREACION DE PAQUETE: Paquete para los procedimientos de Altas, Bajas y Modificaciones de los registros de las tablas del sistema
 * Autor: David Giraldez Sanchez
 * Tutor: Jordi Ferrer Duran
 */ 
   
-- NOTA: Acentos eliminados intencionadamente para facilitar la lectura con cualquier configuracion del cliente.

-- ESTE SCRIPT DEBERA LANZARSE COMO USUARIO TFG, O EL USUARIO QUE QUERAMOS UTILIZAR COMO ESQUEMA PRINCIPAL DE LA APLICACION
-- AL LANZAR ESTE SCRIPT COMO USUARIO TFG, EL PAQUETE SE CREA EN SU ESQUEMA Y ES DE SU PROPIEDAD.

/*****************
 ***** ALTAS *****
 *****************/
   
   PROCEDURE ALTA_ACCION ( 
   pNombre IN ACCION.nombre_accion%TYPE, 
   pF_impl IN ACCION.f_implantacion_acc%TYPE, 
   pF_est IN ACCION.f_estado_acc%TYPE, 
   pURL IN ACCION.url_accion%TYPE, 
   pId_vuln IN ACCION.id_vulnerabilidad%TYPE, 
   pId_est IN ACCION.id_estado_acc%TYPE, 
   pResponsable IN ACCION.responsable%TYPE, 
   RSP OUT VARCHAR2);
   
   PROCEDURE ALTA_ANALISIS ( 
   pNombre IN ANALISIS.nombre_analisis%TYPE, 
   pTipo IN ANALISIS.tipo_analisis%TYPE, 
   pEquipo IN ANALISIS.nombre_equipo%TYPE,
   pF_inicio IN ANALISIS.f_inicio_analisis%TYPE, 
   pF_fin IN ANALISIS.f_fin_analisis%TYPE,
   pURL IN ANALISIS.url_analisis%TYPE, 
   RSP OUT VARCHAR2);
   
   PROCEDURE ALTA_ASIGNADASESION ( 
   pSesion IN ASIGNADASESION.sesion_id_sesion%TYPE, 
   pEmpleado IN ASIGNADASESION.empleado_id_empleado%TYPE, 
   RSP OUT VARCHAR2);
      
   PROCEDURE ALTA_AUDITORIA ( 
   pNombre IN AUDITORIA.nombre_auditoria%TYPE, 
   pTipo IN AUDITORIA.tipo_auditoria%TYPE, 
   pF_inicio IN AUDITORIA.f_inicio_auditoria%TYPE, 
   RSP OUT VARCHAR2);
         
   PROCEDURE ALTA_DEPARTAMENTO ( 
   pNombre IN DEPARTAMENTO.nombre_depto%TYPE, 
   RSP OUT VARCHAR2);
   
   PROCEDURE ALTA_EMPLEADO (  
   pDNI IN EMPLEADO.dni_empleado%TYPE, 
   pNombre IN EMPLEADO.nombre_emp%TYPE,
   pAp1 IN EMPLEADO.apellido1_emp%TYPE, 
   pAp2 IN EMPLEADO.apellido2_emp%TYPE, 
   pEmail IN EMPLEADO.email_empleado%TYPE, 
   pTfno IN EMPLEADO.tfno_empleado%TYPE, 
   pDepto IN EMPLEADO.id_departamento%TYPE,
   RSP OUT VARCHAR2);
            
   PROCEDURE ALTA_ESTADOACCION ( 
   pId_estado IN ESTADOACCION.id_estado_acc%TYPE,
   pEstado IN ESTADOACCION.estado_accion%TYPE, 
   RSP OUT VARCHAR2);
               
   PROCEDURE ALTA_ESTADOVULN ( 
   pId_estado IN ESTADOVULN.id_estado_vuln%TYPE,
   pEstado IN ESTADOVULN.estado_vuln%TYPE, 
   RSP OUT VARCHAR2);
                  
   PROCEDURE ALTA_ESTUDIOPROCESO ( 
   pAnalisis IN ESTUDIOPROCESO.id_analisis%TYPE,
   pProceso IN ESTUDIOPROCESO.id_proceso%TYPE,
   pFecha IN ESTUDIOPROCESO.f_estudioproceso%TYPE, 
   RSP OUT VARCHAR2);
                     
   PROCEDURE ALTA_INCUMPLIMIENTO ( 
   pFecha IN INCUMPLIMIENTO.f_deteccion_incumplimiento%TYPE,
   pAuditoria IN INCUMPLIMIENTO.id_auditoria%TYPE,
   pEmpleado IN INCUMPLIMIENTO.id_empleado%TYPE,
   pPolitica IN INCUMPLIMIENTO.id_politica%TYPE, 
   RSP OUT VARCHAR2);
                        
   PROCEDURE ALTA_MUESTREO ( 
   pPolitica IN MUESTREO.id_politica%TYPE,
   pAuditoria IN MUESTREO.id_auditoria%TYPE,
   pEmpleado IN MUESTREO.id_empleado%TYPE,
   pF_muestreo IN MUESTREO.f_muestreo%TYPE,
   RSP OUT VARCHAR2);
      
   PROCEDURE ALTA_POLITICA ( 
   pNombre IN POLITICA.nombre_politica%TYPE,
   pURL IN POLITICA.url_politica%TYPE, 
   RSP OUT VARCHAR2);
         
   PROCEDURE ALTA_PROCESO ( 
   pNombre IN PROCESO.nombre_proceso%TYPE,
   pURL IN PROCESO.url_proceso%TYPE,
   RSP OUT VARCHAR2);
            
   PROCEDURE ALTA_SESION ( 
   pTitulo IN SESION.titulo_sesion%TYPE,
   pModalidad IN SESION.modalidad_sesion%TYPE, 
   pF_inicio IN SESION.f_inicio_sesion%TYPE,
   RSP OUT VARCHAR2);
               
   PROCEDURE ALTA_VULNERABILIDAD ( 
   pAnalisis IN VULNERABILIDAD.id_analisis%TYPE,
   pProceso IN VULNERABILIDAD.id_proceso%TYPE, 
   pF_deteccion IN VULNERABILIDAD.f_deteccion_vuln%TYPE,
   pEstado IN VULNERABILIDAD.id_estado_vuln%TYPE,
   pCritica IN VULNERABILIDAD.es_vuln_critica%TYPE,
   pNombre IN VULNERABILIDAD.nombre_vuln%TYPE,
   pURL IN VULNERABILIDAD.url_vuln%TYPE,
   RSP OUT VARCHAR2);
   
/*****************
 ***** BAJAS *****
 *****************/
   
   PROCEDURE BAJA_ACCION (
   pId IN ACCION.id_accion%TYPE, 
   RSP OUT VARCHAR2);
   
   PROCEDURE BAJA_ANALISIS (
   pId IN ANALISIS.id_analisis%TYPE, 
   RSP OUT VARCHAR2);
   
   PROCEDURE BAJA_ASIGNADASESION (
   pSesion IN ASIGNADASESION.sesion_id_sesion%TYPE, 
   pEmpleado IN ASIGNADASESION.empleado_id_empleado%TYPE, 
   RSP OUT VARCHAR2);
      
   PROCEDURE BAJA_AUDITORIA (
   pId IN AUDITORIA.id_auditoria%TYPE, 
   RSP OUT VARCHAR2);
         
   PROCEDURE BAJA_DEPARTAMENTO (
   pId IN DEPARTAMENTO.id_departamento%TYPE, 
   RSP OUT VARCHAR2);
            
   PROCEDURE BAJA_EMPLEADO (
   pId IN EMPLEADO.id_empleado%TYPE, 
   RSP OUT VARCHAR2);
              
   PROCEDURE BAJA_ESTADOACCION (
   pId IN ESTADOACCION.id_estado_acc%TYPE, 
   RSP OUT VARCHAR2);
                
   PROCEDURE BAJA_ESTADOVULN (
   pId IN ESTADOVULN.id_estado_vuln%TYPE, 
   RSP OUT VARCHAR2);
                  
   PROCEDURE BAJA_ESTUDIOPROCESO (
   pAnalisis IN ESTUDIOPROCESO.id_analisis%TYPE, 
   pProceso IN ESTUDIOPROCESO.id_proceso%TYPE, 
   RSP OUT VARCHAR2);
                    
   PROCEDURE BAJA_INCUMPLIMIENTO (
   pId IN INCUMPLIMIENTO.id_incumplimiento%TYPE, 
   RSP OUT VARCHAR2);
                                       
   PROCEDURE BAJA_MUESTREO (
   pPolitica IN MUESTREO.id_politica%TYPE, 
   pAuditoria IN MUESTREO.id_auditoria%TYPE, 
   pEmpleado IN MUESTREO.id_empleado%TYPE, 
   RSP OUT VARCHAR2);
                   
   PROCEDURE BAJA_POLITICA (
   pId IN POLITICA.id_politica%TYPE, 
   RSP OUT VARCHAR2);
                       
   PROCEDURE BAJA_PROCESO (
   pId IN PROCESO.id_proceso%TYPE, 
   RSP OUT VARCHAR2);
                           
   PROCEDURE BAJA_SESION (
   pId IN SESION.id_sesion%TYPE, 
   RSP OUT VARCHAR2);
                               
   PROCEDURE BAJA_VULNERABILIDAD (
   pId IN VULNERABILIDAD.id_vulnerabilidad%TYPE, 
   RSP OUT VARCHAR2);
    
/************************
 **** MODIFICACIONES ****
 ************************/
   
   PROCEDURE MODIFICA_ACCION (
   pId_accion IN ACCION.id_accion%TYPE,   
   pNombre IN ACCION.nombre_accion%TYPE, 
   pF_impl IN ACCION.f_implantacion_acc%TYPE, 
   pF_est IN ACCION.f_estado_acc%TYPE, 
   pURL IN ACCION.url_accion%TYPE,  
   pId_est IN ACCION.id_estado_acc%TYPE, 
   pResponsable IN ACCION.responsable%TYPE,  
   RSP OUT VARCHAR2);
   
   PROCEDURE MODIFICA_ANALISIS ( 
   pId IN ANALISIS.id_analisis%TYPE,   
   pNombre IN ANALISIS.nombre_analisis%TYPE, 
   pTipo IN ANALISIS.tipo_analisis%TYPE, 
   pEquipo IN ANALISIS.nombre_equipo%TYPE,
   pF_inicio IN ANALISIS.f_inicio_analisis%TYPE, 
   pF_fin IN ANALISIS.f_fin_analisis%TYPE,
   pURL IN ANALISIS.url_analisis%TYPE, 
   RSP OUT VARCHAR2);
   
   PROCEDURE MODIFICA_ASIGNADASESION ( 
   pSesion IN ASIGNADASESION.sesion_id_sesion%TYPE, 
   pEmpleado IN ASIGNADASESION.empleado_id_empleado%TYPE, 
   pFinalizada IN ASIGNADASESION.ha_finalizado_sesion%TYPE, 
   pF_fin IN ASIGNADASESION.f_fin_sesion%TYPE, 
   RSP OUT VARCHAR2);
      
   PROCEDURE MODIFICA_AUDITORIA ( 
   pId IN AUDITORIA.id_auditoria%TYPE,   
   pNombre IN AUDITORIA.nombre_auditoria%TYPE,
   pTipo IN AUDITORIA.tipo_auditoria%TYPE,
   pF_inicio IN AUDITORIA.f_inicio_auditoria%TYPE, 
   pF_fin IN AUDITORIA.f_fin_auditoria%TYPE, 
   RSP OUT VARCHAR2);
         
   PROCEDURE MODIFICA_DEPARTAMENTO ( 
   pId IN DEPARTAMENTO.id_departamento%TYPE,   
   pNombre IN DEPARTAMENTO.nombre_depto%TYPE, 
   RSP OUT VARCHAR2);
   
   PROCEDURE MODIFICA_EMPLEADO (  
   pId IN EMPLEADO.id_empleado%TYPE,   
   pDNI IN EMPLEADO.dni_empleado%TYPE, 
   pNombre IN EMPLEADO.nombre_emp%TYPE,
   pAp1 IN EMPLEADO.apellido1_emp%TYPE, 
   pAp2 IN EMPLEADO.apellido2_emp%TYPE, 
   pEmail IN EMPLEADO.email_empleado%TYPE, 
   pTfno IN EMPLEADO.tfno_empleado%TYPE, 
   pActivo IN EMPLEADO.es_empleado_en_activo%TYPE, 
   pDepto IN EMPLEADO.id_departamento%TYPE,
   RSP OUT VARCHAR2);
            
   PROCEDURE MODIFICA_ESTADOACCION ( 
   pId IN ESTADOACCION.id_estado_acc%TYPE,
   pEstado IN ESTADOACCION.estado_accion%TYPE, 
   RSP OUT VARCHAR2);
               
   PROCEDURE MODIFICA_ESTADOVULN ( 
   pId IN ESTADOVULN.id_estado_vuln%TYPE,
   pEstado IN ESTADOVULN.estado_vuln%TYPE, 
   RSP OUT VARCHAR2);
                  
   PROCEDURE MODIFICA_ESTUDIOPROCESO ( 
   pAnalisis IN ESTUDIOPROCESO.id_analisis%TYPE,
   pProceso IN ESTUDIOPROCESO.id_proceso%TYPE,
   pFecha IN ESTUDIOPROCESO.f_estudioproceso%TYPE, 
   RSP OUT VARCHAR2);
                     
   PROCEDURE MODIFICA_INCUMPLIMIENTO ( 
   pId IN INCUMPLIMIENTO.id_incumplimiento%TYPE,   
   pFecha IN INCUMPLIMIENTO.f_deteccion_incumplimiento%TYPE,
   RSP OUT VARCHAR2);
                        
   PROCEDURE MODIFICA_MUESTREO ( 
   pPolitica IN MUESTREO.id_politica%TYPE,
   pAuditoria IN MUESTREO.id_auditoria%TYPE,
   pEmpleado IN MUESTREO.id_empleado%TYPE,
   pF_muestreo IN MUESTREO.f_muestreo%TYPE,
   RSP OUT VARCHAR2);
      
   PROCEDURE MODIFICA_POLITICA ( 
   pId IN POLITICA.id_politica%TYPE,   
   pNombre IN POLITICA.nombre_politica%TYPE,
   pURL IN POLITICA.url_politica%TYPE, 
   RSP OUT VARCHAR2);
         
   PROCEDURE MODIFICA_PROCESO ( 
   pId IN PROCESO.id_proceso%TYPE,   
   pNombre IN PROCESO.nombre_proceso%TYPE,
   pURL IN PROCESO.url_proceso%TYPE, 
   RSP OUT VARCHAR2);
            
   PROCEDURE MODIFICA_SESION ( 
   pId IN SESION.id_sesion%TYPE,   
   pTitulo IN SESION.titulo_sesion%TYPE,
   pModalidad IN SESION.modalidad_sesion%TYPE, 
   pF_inicio IN SESION.f_inicio_sesion%TYPE,
   RSP OUT VARCHAR2);
               
   PROCEDURE MODIFICA_VULNERABILIDAD ( 
   pId IN VULNERABILIDAD.id_vulnerabilidad%TYPE,   
   pF_deteccion IN VULNERABILIDAD.f_deteccion_vuln%TYPE,
   pEstado IN VULNERABILIDAD.id_estado_vuln%TYPE,
   pCritica IN VULNERABILIDAD.es_vuln_critica%TYPE,
   pNombre IN VULNERABILIDAD.nombre_vuln%TYPE,
   pURL IN VULNERABILIDAD.url_vuln%TYPE,
   RSP OUT VARCHAR2);

END PKG_ABM;
/