CREATE OR REPLACE PACKAGE BODY PKG_ESTADISTICAS AS 

/* -- FICHERO PARA CREACION DE CUERPO DE PAQUETE: Paquete para los procedimientos de consulta de los registros de la tabla ESTADISTICA
 * Autor: David Giraldez Sanchez
 * Tutor: Jordi Ferrer Duran
 */

/********************************
**** CONSULTAS DE RESULTADOS ****
*********************************/

PROCEDURE VER_RESULTADO_CONSULTA_1 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vDescripcion	NVARCHAR2(300);
   vResultado NUMBER(10);
   
  BEGIN
  -- Proceso de gestión interno que, teniendo en cuenta toda la información de que se dispone en la BD, ha tenido un mayor numero de vulnerabilidades detectadas.
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 1.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_1';
  SELECT descripcion_consulta, resultado_consulta INTO vDescripcion, vResultado FROM ESTADISTICA WHERE id_consulta = 1;
  -- RSP := 'C1: '||vDescripcion||' PROCESO NUMERO: '||vResultado;
  RSP := 'C1 - PROCESO NUMERO: '||vResultado;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
  	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_1;
  
PROCEDURE VER_RESULTADO_CONSULTA_2 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vDescripcion	NVARCHAR2(300);
   vResultado NUMBER(10);
   
  BEGIN
  -- Porcentaje de vulnerabilidades que, en el momento de ejecutar la consulta, están totalmente mitigadas.
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 2.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_2';
  SELECT descripcion_consulta, resultado_consulta INTO vDescripcion, vResultado FROM ESTADISTICA WHERE id_consulta = 2 ;
  -- RSP := 'C2: '||vDescripcion||' PORCENTAJE: '||vResultado;
  RSP := 'C2 - PORCENTAJE: '||vResultado;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
  	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_2;

PROCEDURE VER_RESULTADO_CONSULTA_3 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vDescripcion	NVARCHAR2(300);
   vResultado NUMBER(10);
   
  BEGIN
  -- Número total de acciones de mitigación que, en el momento de ejecutar la consulta, no están totalmente acabadas.
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 3.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_3';
  SELECT descripcion_consulta, resultado_consulta INTO vDescripcion, vResultado FROM ESTADISTICA WHERE id_consulta = 3 ;
  -- RSP := 'C3: '||vDescripcion||' TOTAL: '||vResultado;
  RSP := 'C3 - TOTAL: '||vResultado;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
  	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_3;
  
PROCEDURE VER_RESULTADO_CONSULTA_4 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vDescripcion	NVARCHAR2(300);
   vResultado NUMBER(10);
   
  BEGIN
  -- Política de seguridad que, en el momento de ejecutar la consulta, ha tenido más incumplimientos (teniendo en cuenta todos los departamentos de la empresa).
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 4.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_4';
  SELECT descripcion_consulta, resultado_consulta INTO vDescripcion, vResultado FROM ESTADISTICA WHERE id_consulta = 4 ;
  -- RSP := 'C4: '||vDescripcion||' POLITICA: '||vResultado;
  RSP := 'C4 - POLITICA: '||vResultado;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
  	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_4;

PROCEDURE VER_RESULTADO_CONSULTA_5 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vPorcentaje 	NUMBER(4,2);
   vDescripcion	NVARCHAR2(300);
   
  BEGIN
  -- Dado un determinado departamento de la empresa, y teniendo en cuenta el momento de ejecutar la consulta, porcentaje de usuarios del departamento que no han acabado todas las formaciones de seguridad asignadas.
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 5.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_5';
  
  SELECT porc_empls_con_ses_pend INTO vPorcentaje FROM DEPARTAMENTO WHERE id_departamento = &Departamento;
  -- SELECT descripcion_consulta INTO vDescripcion FROM ESTADISTICA WHERE id_consulta = 5 ;
  vDescripcion := 'Dado un determinado departamento de la empresa, y teniendo en cuenta el momento de ejecutar la consulta, porcentaje de usuarios del departamento que no han acabado todas las formaciones de seguridad asignadas.';
  -- RSP := 'C5: '||vDescripcion||' PORCENTAJE: '||vPorcentaje;
  RSP := 'C5 - PORCENTAJE: '||vPorcentaje;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
  	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_5;

PROCEDURE VER_RESULTADO_CONSULTA_6 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vDescripcion	NVARCHAR2(300);
   vResultado NUMBER(10);
   
  BEGIN
  -- Teniendo en cuenta todas las auditorías externas realizadas, año en el cual se han detectado más incumplimientos (teniendo en cuenta sólo los detectados durante la auditoría).
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 6.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_6';
  SELECT descripcion_consulta, resultado_consulta INTO vDescripcion, vResultado FROM ESTADISTICA WHERE id_consulta = 6 ;
  -- RSP := 'C6: '||vDescripcion||' AÑO: '||vResultado;
  RSP := 'C6 - AÑO: '||vResultado;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
  	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_6;

PROCEDURE VER_RESULTADO_CONSULTA_7 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vDescripcion	NVARCHAR2(300);
   vResultado NUMBER(10);
   
  BEGIN
  -- Porcentaje de vulnerabilidades críticas que, en el momento de ejecutar la consulta, tienen alguna acción de mitigación abierta (que no esté en estado “acabada”).
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 7.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_7';
  SELECT descripcion_consulta, resultado_consulta INTO vDescripcion, vResultado FROM ESTADISTICA WHERE id_consulta = 7 ;
  -- RSP := 'C7: '||vDescripcion||' PORCENTAJE: '||vResultado;
  RSP := 'C7 - PORCENTAJE: '||vResultado;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
  	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_7;

PROCEDURE VER_RESULTADO_CONSULTA_8 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vDescripcion	NVARCHAR2(300);
   vResultado NUMBER(10);
   vTitulo	NVARCHAR2(100);
   
  BEGIN
  -- Teniendo en cuenta el último año (el anterior al año en curso), título de la sesión formativa telemática que ha tenido un porcentaje menor de participantes en total.
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 7.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_7';
  SELECT descripcion_consulta, resultado_consulta INTO vDescripcion, vResultado FROM ESTADISTICA WHERE id_consulta = 7 ;
  SELECT TITULO_SESION INTO vTitulo FROM SESION WHERE id_sesion = vResultado;
  -- RSP := 'C8: '||vDescripcion||' SESION: '||vResultado||', con titulo: '||vTitulo;
  RSP := 'C8 - SESION: '||vResultado||', con titulo: '||vTitulo;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_8;

PROCEDURE VER_RESULTADO_CONSULTA_9 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vDescripcion	NVARCHAR2(300);
   vResultado NUMBER(10);
   
  BEGIN
  -- Número de vulnerabilidades críticas detectadas internamente teniendo en cuenta todos los datos de que se dispone. Se consideran detectadas internamente si se detectaron en posterioridad al análisis realizado al inicio del proyecto por la consultora externa.
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 9.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_9';
  SELECT descripcion_consulta, resultado_consulta INTO vDescripcion, vResultado FROM ESTADISTICA WHERE id_consulta = 9 ;
  -- RSP := 'C9: '||vDescripcion||' NUMERO: '||vResultado;
  RSP := 'C9 - NUMERO: '||vResultado;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
  	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_9;

PROCEDURE VER_RESULTADO_CONSULTA_10 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vDescripcion	NVARCHAR2(300);
   vResultado NUMBER(10);
   
  BEGIN
  -- En el momento de ejecutar la consulta, porcentaje de acciones de mitigación en el sistema que están en los estados “en proceso” o “en revisión”.
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 10.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_10';
  SELECT descripcion_consulta, resultado_consulta INTO vDescripcion, vResultado FROM ESTADISTICA WHERE id_consulta = 10 ;
  -- RSP := 'C10: '||vDescripcion||' Porcentaje: '||vResultado;
  RSP := 'C10 - Porcentaje: '||vResultado;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
  	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_10;

PROCEDURE VER_RESULTADO_CONSULTA_11 ( 
   RSP OUT VARCHAR2) AS 

   PAR_IN	VARCHAR2(1000);
   PROC     VARCHAR2(100);
   vDescripcion	NVARCHAR2(300);
   vResultado NUMBER(10);
   vNombre	NVARCHAR2(25);
   vAp1	NVARCHAR2(50);
   vAp2	NVARCHAR2(50);
   
  BEGIN
  -- Teniendo en cuenta todas las acciones de mitigación en estado “en proceso”, persona responsable con más acciones asignadas.
  PAR_IN := 'Mostrar el resultado de la consulta estadistica numero 11.';
  PROC := 'PKG_ESTADISTICAS.VER_RESULTADO_CONSULTA_11';
  SELECT descripcion_consulta, resultado_consulta INTO vDescripcion, vResultado FROM ESTADISTICA WHERE id_consulta = 11;
  SELECT nombre_emp, apellido1_emp, apellido1_emp INTO vNombre, vAp1, vAp2 FROM EMPLEADO WHERE id_empleado = vResultado;
  -- RSP := 'C11: '||vDescripcion||' Empleado: '||vResultado||', de nombre: '||vNombre||' '||vAp1||' '||vAp2;
  RSP := 'C11 - Empleado: '||vResultado||', de nombre: '||vNombre||' '||vAp1||' '||vAp2;
  DBMS_OUTPUT.PUT_LINE(RSP);
  INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);
  
  -- Si ha saltado una excepcion, la procesamos  
  EXCEPTION
  	WHEN NO_DATA_FOUND THEN
		RSP:= 'RESULTADO: ERROR: NO EXISTE EL REGISTRO BUSCADO.';
		INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES (PROC,PAR_IN,RSP);
	   COMMIT;
    WHEN OTHERS THEN 
        RSP := 'RESULTADO: ERROR: ' || TO_CHAR(SQLERRM(-SQLCODE));
        INSERT INTO LOGOPERACIONES (NOMBRE_PROCEDIMIENTO, PARAMS_ENTRADA, RESULTADO) VALUES(PROC,PAR_IN,RSP);

  END VER_RESULTADO_CONSULTA_11;



END PKG_ESTADISTICAS;