-- FICHERO PARA CREACION DE SECUENCIAS Y DISPARADORES: 6_SECUENCIAS_Y_DISPARADORES.sql
-- Autor: David Giraldez Sanchez
-- Tutor: Jordi Ferrer Duran

-- NOTA: Acentos eliminados intencionadamente para facilitar la lectura con cualquier configuracion del cliente.

-- TODOS LOS COMANDOS DE ESTE SCRIPT DEBERAN LANZARSE COMO USUARIO TFG, O EL USUARIO QUE QUERAMOS UTILIZAR COMO ESQUEMA PRINCIPAL DE LA APLICACION

-- COMENZARIAMOS POR ELIMINAR LAS TABLAS Y PAQUETES, POR SI EXISTEN; SI HEMOS CREADO EL ESQUEMA CON EL SCRIPT 1-Tablespace_y_Esquema.sql, SE HABRIAN ELIMINADO YA

/* ELIMINAMOS LAS SECUENCIAS POR SI EXISTÍAN
DROP SEQUENCE "TFG"."SEQ_ID_ACCION";
DROP SEQUENCE "TFG"."SEQ_ID_ANALISIS";
DROP SEQUENCE "TFG"."SEQ_ID_AUDITORIA";
DROP SEQUENCE "TFG"."SEQ_ID_DEPARTAMENTO";
DROP SEQUENCE "TFG"."SEQ_ID_EMPLEADO";
DROP SEQUENCE "TFG"."SEQ_ID_INCUMPLIMIENTO";
DROP SEQUENCE "TFG"."SEQ_ID_POLITICA";
DROP SEQUENCE "TFG"."SEQ_ID_PROCESO";
DROP SEQUENCE "TFG"."SEQ_ID_SESION";
DROP SEQUENCE "TFG"."SEQ_ID_VULNERABILIDAD";
DROP SEQUENCE "TFG"."SEQ_ID_LOGOPERACIONES";
*/

/************************************* 
**** TRIGGERS "AUTOINCREMENTALES" ****
**************************************/

-- TABLA ACCION
CREATE SEQUENCE SEQ_ID_ACCION START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_ACCION 
BEFORE INSERT ON ACCION 
FOR EACH ROW 
WHEN (NEW.id_accion IS NULL) 
BEGIN
:new.id_accion := SEQ_ID_ACCION.NEXTVAL;
END;
/
-- TABLA ANALISIS
CREATE SEQUENCE SEQ_ID_ANALISIS START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_ANALISIS
BEFORE INSERT ON TFG.ANALISIS
FOR EACH ROW 
WHEN (NEW.id_analisis IS NULL) 
BEGIN
:NEW.id_analisis := SEQ_ID_ANALISIS.NEXTVAL;
END;
/
-- TABLA AUDITORIA
CREATE SEQUENCE SEQ_ID_AUDITORIA START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_AUDITORIA 
BEFORE INSERT ON TFG.AUDITORIA 
FOR EACH ROW 
WHEN (NEW.id_auditoria IS NULL) 
BEGIN
:NEW.id_auditoria := SEQ_ID_AUDITORIA.NEXTVAL;
END;
/
-- TABLA DEPARTAMENTO
CREATE SEQUENCE SEQ_ID_DEPARTAMENTO START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_DEPARTAMENTO 
BEFORE INSERT ON TFG.DEPARTAMENTO
FOR EACH ROW 
WHEN (NEW.id_departamento IS NULL) 
BEGIN
:NEW.id_departamento := SEQ_ID_DEPARTAMENTO.NEXTVAL;
END;
/
-- TABLA EMPLEADO
CREATE SEQUENCE SEQ_ID_EMPLEADO START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_EMPLEADO 
BEFORE INSERT ON TFG.EMPLEADO
FOR EACH ROW 
WHEN (NEW.id_empleado IS NULL) 
BEGIN
:NEW.id_empleado := SEQ_ID_EMPLEADO.NEXTVAL;
END;
/
-- TABLA INCUMPLIMIENTO
CREATE SEQUENCE SEQ_ID_INCUMPLIMIENTO START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_INCUMPLIMIENTO 
BEFORE INSERT ON TFG.INCUMPLIMIENTO
FOR EACH ROW 
WHEN (NEW.id_incumplimiento IS NULL) 
BEGIN
:NEW.id_incumplimiento := SEQ_ID_INCUMPLIMIENTO.NEXTVAL;
END;
/
-- TABLA POLITICA
CREATE SEQUENCE SEQ_ID_POLITICA START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_POLITICA 
BEFORE INSERT ON TFG.POLITICA
FOR EACH ROW 
WHEN (NEW.id_politica IS NULL) 
BEGIN
:NEW.id_politica := SEQ_ID_POLITICA.NEXTVAL;
END;
/
-- TABLA PROCESO
CREATE SEQUENCE SEQ_ID_PROCESO START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_PROCESO 
BEFORE INSERT ON TFG.PROCESO
FOR EACH ROW 
WHEN (NEW.id_proceso IS NULL) 
BEGIN
:NEW.id_proceso := SEQ_ID_PROCESO.NEXTVAL;
END;
/
-- TABLA SESION
CREATE SEQUENCE SEQ_ID_SESION START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_SESION 
BEFORE INSERT ON TFG.SESION
FOR EACH ROW 
WHEN (NEW.id_sesion IS NULL) 
BEGIN
:NEW.id_sesion := SEQ_ID_SESION.NEXTVAL;
END;
/
-- TABLA VULNERABILIDAD
CREATE SEQUENCE SEQ_ID_VULNERABILIDAD START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_VULNERABILIDAD 
BEFORE INSERT ON TFG.VULNERABILIDAD
FOR EACH ROW 
WHEN (NEW.id_vulnerabilidad IS NULL) 
BEGIN
:NEW.id_vulnerabilidad := SEQ_ID_VULNERABILIDAD.NEXTVAL;
END;
/
-- TABLA LOGOPERACIONES
CREATE SEQUENCE SEQ_ID_LOGOPERACIONES START WITH 1 INCREMENT BY 1 NOCACHE ORDER ;

CREATE OR REPLACE TRIGGER TRG_INSERTAR_LOGOPERACIONES 
BEFORE INSERT ON TFG.LOGOPERACIONES
FOR EACH ROW 
WHEN (NEW.id_log IS NULL) 
BEGIN
:NEW.id_log := SEQ_ID_LOGOPERACIONES.NEXTVAL;
SELECT SYSDATE INTO :NEW.f_ejecucion FROM DUAL;
SELECT USER INTO :NEW.usuario FROM DUAL;
END;
/

/****************************** 
**** TRIGGERS ESTADISTICOS ****
*******************************/

CREATE OR REPLACE TRIGGER TRG_ACTUALIZAR_CONSULTA_1 
AFTER DELETE OR INSERT ON PROCESO 
DECLARE 
    RSP VARCHAR2(300);
BEGIN
    TFG.PKG_FUNCIONAMIENTO.ACTUALIZAR_CONSULTA_1(RSP);
END;
/
CREATE OR REPLACE TRIGGER TRG_ACTUALIZAR_CONSULTA_2 
AFTER DELETE OR INSERT OR UPDATE ON VULNERABILIDAD 
DECLARE 
    RSP VARCHAR2(300);
BEGIN
    TFG.PKG_FUNCIONAMIENTO.ACTUALIZAR_CONSULTA_2(RSP);
END;
/
CREATE OR REPLACE TRIGGER TRG_ACTUALIZAR_CONSULTA_3 
AFTER DELETE OR INSERT OR UPDATE ON ACCION 
DECLARE 
    RSP VARCHAR2(300);
BEGIN
  TFG.PKG_FUNCIONAMIENTO.ACTUALIZAR_CONSULTA_3(RSP);
END;
/
CREATE OR REPLACE TRIGGER TRG_ACTUALIZAR_CONSULTA_4 
AFTER INSERT OR DELETE ON INCUMPLIMIENTO 
DECLARE 
    RSP VARCHAR2(300);
BEGIN
  TFG.PKG_FUNCIONAMIENTO.ACTUALIZAR_CONSULTA_4(RSP);
END;
/
CREATE OR REPLACE TRIGGER TRG_ACTUALIZAR_CONSULTA_6 
AFTER INSERT OR UPDATE ON INCUMPLIMIENTO 
DECLARE 
    RSP VARCHAR2(300);
BEGIN
  TFG.PKG_FUNCIONAMIENTO.ACTUALIZAR_CONSULTA_6(RSP);
END;
/
CREATE OR REPLACE TRIGGER TRG_ACTUALIZAR_CONSULTA_7 
AFTER DELETE OR INSERT OR UPDATE ON ACCION 
DECLARE 
    RSP VARCHAR2(300);
BEGIN
    TFG.PKG_FUNCIONAMIENTO.ACTUALIZAR_CONSULTA_7(RSP);
END;
/
CREATE OR REPLACE TRIGGER TRG_ACTUALIZAR_CONSULTA_8 
AFTER DELETE OR INSERT ON ASIGNADASESION 
DECLARE
    RSP VARCHAR2(300);
BEGIN
    TFG.PKG_FUNCIONAMIENTO.ACTUALIZAR_CONSULTA_8(RSP);
END;
/
CREATE OR REPLACE TRIGGER TRG_ACTUALIZAR_CONSULTA_9 
AFTER DELETE OR INSERT OR UPDATE ON VULNERABILIDAD 
DECLARE
    RSP VARCHAR2(300);
BEGIN
    TFG.PKG_FUNCIONAMIENTO.ACTUALIZAR_CONSULTA_9(RSP);
END;
/
CREATE OR REPLACE TRIGGER TRG_ACTUALIZAR_CONSULTA_10 
AFTER DELETE OR INSERT OR UPDATE ON ACCION 
DECLARE
    RSP VARCHAR2(300);
BEGIN
  TFG.PKG_FUNCIONAMIENTO.ACTUALIZAR_CONSULTA_10(RSP);
END;
/
CREATE OR REPLACE TRIGGER TRG_ACTUALIZAR_CONSULTA_11 
AFTER DELETE OR INSERT OR UPDATE ON ACCION 
DECLARE
    RSP VARCHAR2(300);
BEGIN
    TFG.PKG_FUNCIONAMIENTO.ACTUALIZAR_CONSULTA_11(RSP);
END;
/